Loading...
Searching...
No Matches
itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder > Class Template Reference

`#include <itkBSplineInterpolationDerivativeWeightFunction.h>`

## Detailed Description

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>
class itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >

Returns the weights over the support region used for B-spline interpolation/reconstruction.

Computes/evaluate the B-spline interpolation weights over the support region of the B-spline.

This class is templated over the coordinate representation type, the space dimension and the spline order.

See also
  Point
  Index
  ContinuousIndex

Definition at line 44 of file itkBSplineInterpolationDerivativeWeightFunction.h.

Inheritance diagram for itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | ContinuousIndexType
using | IndexType
using | Pointer = SmartPointer<Self>
using | Self = BSplineInterpolationDerivativeWeightFunction
using | SizeType
using | Superclass = BSplineInterpolationWeightFunctionBase<TCoordRep, VSpaceDimension, VSplineOrder>
using | WeightsType
Public Types inherited from itk::BSplineInterpolationWeightFunctionBase< float, 2, 3 >
using | ConstPointer
using | ContinuousIndexType
using | IndexType
using | Pointer
using | Self
using | SizeType
using | Superclass
using | WeightsType

## Public Member Functions

virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (BSplineInterpolationDerivativeWeightFunction)
| itkStaticConstMacro (SpaceDimension, unsigned int, VSpaceDimension)
| itkStaticConstMacro (SplineOrder, unsigned int, VSplineOrder)
virtual void | SetDerivativeDirection (unsigned int dir)
Public Member Functions inherited from itk::BSplineInterpolationWeightFunctionBase< float, 2, 3 >
void | ComputeStartIndex (const ContinuousIndexType &index, IndexType &startIndex) const
WeightsType | Evaluate (const ContinuousIndexType &index) const override
| ITK_DISALLOW_COPY_AND_MOVE (BSplineInterpolationWeightFunctionBase)
| itkStaticConstMacro (SpaceDimension, unsigned int, VSpaceDimension)

## Static Public Member Functions

static Pointer | New ()

## Protected Types

using | DerivativeKernelType
using | KernelType
using | OneDWeightsType
using | SecondOrderDerivativeKernelType
Protected Types inherited from itk::BSplineInterpolationWeightFunctionBase< float, 2, 3 >
using | DerivativeKernelPointer
using | DerivativeKernelType
using | KernelPointer
using | KernelType
using | OneDWeightsType
using | SecondOrderDerivativeKernelPointer
using | SecondOrderDerivativeKernelType
using | WeightArrayType

## Protected Member Functions

| BSplineInterpolationDerivativeWeightFunction ()
void | Compute1DWeights (const ContinuousIndexType &index, const IndexType &startIndex, OneDWeightsType &weights1D) const override
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~BSplineInterpolationDerivativeWeightFunction () override=default
Protected Member Functions inherited from itk::BSplineInterpolationWeightFunctionBase< float, 2, 3 >
| BSplineInterpolationWeightFunctionBase ()
virtual void | Compute1DWeights (const ContinuousIndexType &index, const IndexType &startIndex, OneDWeightsType &weights1D) const=0
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~BSplineInterpolationWeightFunctionBase () override=default

## Private Attributes

unsigned int | m_DerivativeDirection {}

## Additional Inherited Members

Static Public Attributes inherited from itk::BSplineInterpolationWeightFunctionBase< float, 2, 3 >
static constexpr unsigned long | NumberOfWeights
static constexpr SizeType | SupportSize
Protected Attributes inherited from itk::BSplineInterpolationWeightFunctionBase< float, 2, 3 >
vnl_matrix< unsigned long > | m_OffsetToIndexTable

## Member Typedef Documentation

## ConstPointer

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::ConstPointer = SmartPointer<const Self>

Definition at line 54 of file itkBSplineInterpolationDerivativeWeightFunction.h.

## ContinuousIndexType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::ContinuousIndexType

ContinuousIndex typedef support.

Definition at line 84 of file itkBSplineInterpolationWeightFunctionBase.h.

## DerivativeKernelType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::DerivativeKernelType

protected

Definition at line 114 of file itkBSplineInterpolationWeightFunctionBase.h.

## IndexType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::IndexType

Index and size typedef support.

Definition at line 80 of file itkBSplineInterpolationWeightFunctionBase.h.

## KernelType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::KernelType

protected

Interpolation kernel types.

Definition at line 112 of file itkBSplineInterpolationWeightFunctionBase.h.

## OneDWeightsType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::OneDWeightsType

protected

Typedef for intermediary 1D weights. The Matrix is at least twice as fast as std::vector< vnl_vector< double > >, probably because of the fixed size at compile time.

Definition at line 124 of file itkBSplineInterpolationWeightFunctionBase.h.

## Pointer

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::Pointer = SmartPointer<Self>

Definition at line 53 of file itkBSplineInterpolationDerivativeWeightFunction.h.

## SecondOrderDerivativeKernelType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::SecondOrderDerivativeKernelType

protected

Definition at line 116 of file itkBSplineInterpolationWeightFunctionBase.h.

## Self

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::Self = BSplineInterpolationDerivativeWeightFunction

Standard class typedefs.

Definition at line 51 of file itkBSplineInterpolationDerivativeWeightFunction.h.

## SizeType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::SizeType

Definition at line 81 of file itkBSplineInterpolationWeightFunctionBase.h.

## Superclass

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::Superclass = BSplineInterpolationWeightFunctionBase<TCoordRep, VSpaceDimension, VSplineOrder>

Definition at line 52 of file itkBSplineInterpolationDerivativeWeightFunction.h.

## WeightsType

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

using itk::BSplineInterpolationWeightFunctionBase< TCoordRep, VSpaceDimension, VSplineOrder >::WeightsType

OutputType typedef support.

Definition at line 77 of file itkBSplineInterpolationWeightFunctionBase.h.

## Constructor & Destructor Documentation

## BSplineInterpolationDerivativeWeightFunction()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::BSplineInterpolationDerivativeWeightFunction | ( |  | ) |

protected

## ~BSplineInterpolationDerivativeWeightFunction()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::~BSplineInterpolationDerivativeWeightFunction | ( |  | ) |

override protected default

## Member Function Documentation

## Compute1DWeights()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

void itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::Compute1DWeights | ( | const ContinuousIndexType & | index,
|  | const IndexType & | startIndex,
|  | OneDWeightsType & | weights1D ) const

override protected

Compute the 1D weights, which are:

, with , in case of the derivative direction, and just for the non-derivative directions.

## GetClassName()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

virtual const char * itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::BSplineInterpolationWeightFunctionBase< float, 2, 3 >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::ITK_DISALLOW_COPY_AND_MOVE | ( | BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::itkStaticConstMacro | ( | SpaceDimension | ,
|  | unsigned int | ,
|  | VSpaceDimension | )

Space dimension.

## itkStaticConstMacro() [2/2]

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::itkStaticConstMacro | ( | SplineOrder | ,
|  | unsigned int | ,
|  | VSplineOrder | )

Spline order.

## New()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

Pointer itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::New | ( |  | ) |

static

New macro for creation of through the object factory.

## PrintSelf()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

void itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

Print the member variables.

## SetDerivativeDirection()

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

virtual void itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::SetDerivativeDirection | ( | unsigned int | dir | ) |

virtual

Set the first order derivative direction.

## Field Documentation

## m_DerivativeDirection

template<class TCoordRep = float, unsigned int VSpaceDimension = 2, unsigned int VSplineOrder = 3>

unsigned int itk::BSplineInterpolationDerivativeWeightFunction< TCoordRep, VSpaceDimension, VSplineOrder >::m_DerivativeDirection {}

private

Member variables.

Definition at line 106 of file itkBSplineInterpolationDerivativeWeightFunction.h.

Generated on 1768596610 for elastix by 1.15.0 |